﻿using UnityEngine;
using System.Collections;

public class GuardMoviment2D : MonoBehaviour {

	private Rigidbody2D m_Rigidbody2D;
	private Animator m_Anim;
	private SpriteRenderer m_SpriteRenderer;
	public float m_MaxSpeed = 10;
	private bool m_FacingRight = true;

	void Start () {
		m_Rigidbody2D = GetComponent<Rigidbody2D> ();
		m_Anim = GetComponent<Animator> ();
		m_SpriteRenderer = GetComponent<SpriteRenderer> ();
	}

	public void Move(GameObject whereTo)
	{
		// The Speed animator parameter is set to the absolute value of the horizontal input.
		//m_Anim.SetFloat("Speed", Mathf.Abs(move));

		// Move the character
		transform.position = Vector3.MoveTowards(transform.position, whereTo.transform.position, m_MaxSpeed * Time.deltaTime);

		// If the input is moving the player right and the player is facing left...
		if (transform.position.x < whereTo.transform.position.x && !m_FacingRight)
		{
			// ... flip the player.
			Flip();
		}
		// Otherwise if the input is moving the player left and the player is facing right...
		else if (transform.position.x > whereTo.transform.position.x && m_FacingRight)
		{
			// ... flip the player
			Flip();
		}
	}

	public void MoveForward()
	{
		// The Speed animator parameter is set to the absolute value of the horizontal input.
		//m_Anim.SetFloat("Speed", Mathf.Abs(move));
		m_Rigidbody2D.velocity = new Vector2(0, 1*m_MaxSpeed/2);
	}

	private void Flip()
	{
		// Switch the way the player is labelled as facing.
		m_FacingRight = !m_FacingRight;

		// Multiply the player's x local scale by -1.
		Vector3 theScale = transform.localScale;
		theScale.x *= -1;
		transform.localScale = theScale;
	}

	public bool FacingRight {
		get { return m_FacingRight; }
	}
}
