﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class InMateScript2 : MonoBehaviour {
	public enum States{
		moving,
		watching,
		chasing
	}

	public States state;

	public float maxSpeed = 1;

	public List<GameObject> waypoints = new List<GameObject>();
	int currentWaypoint;

	float watchTime;

	public GameObject rat;
	public LayerMask mask;

	public Vector3 rot0, rot1;

	public Sprite right, down;

	void Start () {

	}
		
	void Update () {
		rat = GameObject.FindGameObjectWithTag ("rat");

		if (state == States.moving) {
			GetComponent<SpriteRenderer> ().sprite = right;

			transform.position = Vector3.MoveTowards(transform.position, waypoints[currentWaypoint].transform.position, maxSpeed* Time.deltaTime);

			if (currentWaypoint == 0) {
				GetComponent<SpriteRenderer> ().flipX = false;
			}

			if (currentWaypoint == 1) {
				GetComponent<SpriteRenderer> ().flipX = true;
			}

			if (transform.position == waypoints [currentWaypoint].transform.position) {
				state = States.watching;
			}

			LookForRat ();
		}
		if (state == States.watching) {

			GetComponent<SpriteRenderer> ().sprite = down;

			if (currentWaypoint == 0) {
				GetComponent<SpriteRenderer> ().flipX = false;

				transform.rotation = Quaternion.Euler(rot0);
			}

			if (currentWaypoint == 1) {
				GetComponent<SpriteRenderer> ().flipX = false;

				transform.rotation = Quaternion.Euler (rot1);
			}

			watchTime += Time.deltaTime;

			if (watchTime > 2.5f) {
				currentWaypoint++;
				state = States.moving;

				watchTime = 0;

				if (currentWaypoint >= waypoints.Count) 
					currentWaypoint = 0;

			}

			LookForRat ();
		}
		if (state == States.chasing) {
			if (rat != null) {

				Vector3 dir = (rat.transform.position - transform.position).normalized;
				RaycastHit2D hit = Physics2D.Raycast (transform.position, dir, 10, mask);
				if (hit.collider.transform.tag == "rat") {
					transform.position = Vector3.MoveTowards(transform.position, rat.transform.position, maxSpeed* Time.deltaTime);

					if (transform.position.y > rat.transform.position.y ) {
						GetComponent<SpriteRenderer> ().flipX = true;
					}
					if (transform.position.y < rat.transform.position.y ) {
						GetComponent<SpriteRenderer> ().flipX = false;
					}
				} 
				else {
					state = States.moving;
				}
			}
			else {
				state = States.moving;
			}
		}
	}

	void LookForRat() {
		if (rat != null) {

			Vector3 dir = (rat.transform.position - transform.position).normalized;

			RaycastHit2D hit = Physics2D.Raycast (transform.position, dir, 10, mask);
			if (hit.collider != null) {
				print (hit.transform.name);
				if (hit.collider.transform.tag == "rat") {

					if (currentWaypoint == 0) {
						if (hit.collider.transform.position.x < transform.position.x && Mathf.Abs (Vector3.Distance (hit.collider.transform.position, transform.position)) < .3) {
							print ("looking at rat from right");
							state = States.chasing;
						}
					}

					if (currentWaypoint == 1) {
						if (hit.collider.transform.position.x < transform.position.x && Mathf.Abs (Vector3.Distance (hit.collider.transform.position, transform.position)) < .3) {
							print ("looking at rat from left");
							state = States.chasing;
						}
					}
				}
			}
		}
	}
}
