﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class InmateScript3 : MonoBehaviour {

	public enum States{
		moving,
		watching,
		chasing
	}

	public States state;

	public float maxSpeed = 1;

	public List<GameObject> waypoints = new List<GameObject>();
	int currentWaypoint;

	float watchTime;

	public GameObject rat;
	public LayerMask mask;

	public Vector3 rot0, rot1;

	public Sprite right, up, down;

	// Use this for initialization
	void Start () {

	}

	// Update is called once per frame
	void Update () {
		rat = GameObject.FindGameObjectWithTag ("rat");

		if (state == States.moving) {
			transform.position = Vector3.MoveTowards(transform.position, waypoints[currentWaypoint].transform.position, maxSpeed* Time.deltaTime);

			if (currentWaypoint == 0) {
				GetComponent<SpriteRenderer> ().sprite = right;
				GetComponent<SpriteRenderer> ().flipX = false;
			}

			if (currentWaypoint == 1) {
				GetComponent<SpriteRenderer> ().sprite = up;
				GetComponent<SpriteRenderer> ().flipX = false;
			}

			if (currentWaypoint == 2) {
				GetComponent<SpriteRenderer> ().sprite = right;
				GetComponent<SpriteRenderer> ().flipX = true;
			}

			if (currentWaypoint == 3) {
				GetComponent<SpriteRenderer> ().sprite = down;
				GetComponent<SpriteRenderer> ().flipX = false;
			}

			if (transform.position == waypoints [currentWaypoint].transform.position) {
				currentWaypoint++;
				if (currentWaypoint >= waypoints.Count) 
					currentWaypoint = 0;
			}

			//LookForRat ();
		}
	
		if (state == States.chasing) {
			if (rat != null) {

				Vector3 dir = (rat.transform.position - transform.position).normalized;
				RaycastHit2D hit = Physics2D.Raycast (transform.position, dir, 10, mask);

				if (hit.collider.transform.tag == "rat") {
					transform.position = Vector3.MoveTowards(transform.position, rat.transform.position, maxSpeed* Time.deltaTime);

					if (transform.position.y > rat.transform.position.y ) {
						GetComponent<SpriteRenderer> ().flipX = true;
					}
					if (transform.position.y < rat.transform.position.y ) {
						GetComponent<SpriteRenderer> ().flipX = false;
					}
				} 
				else {
					state = States.moving;
				}
			}
			else {
				state = States.moving;
			}
		}
	}

	void LookForRat() {
		if (rat != null) {

			Vector3 dir = (rat.transform.position - transform.position).normalized;

			RaycastHit2D hit = Physics2D.Raycast (transform.position, dir, 10, mask);
			if (hit.collider != null) {
				if (hit.collider.transform.tag == "rat") {

					if (currentWaypoint == 0) {
						if (hit.collider.transform.position.y > transform.position.y && Mathf.Abs (Vector3.Distance (hit.collider.transform.position, transform.position)) < 1) {
							print ("looking up at rat");
							state = States.chasing;
						}
					}

					if (currentWaypoint == 1) {
						if (hit.collider.transform.position.y < transform.position.y && Mathf.Abs (Vector3.Distance (hit.collider.transform.position, transform.position)) < 1) {
							print ("looking down at rat");
							state = States.chasing;
						}
					}
				}
			}
		}
	}
}
