﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using UnityEngine.SceneManagement;

public class MinningScript : MonoBehaviour {

	public LayerMask mask;

	public GameObject rightArrow;
	public GameObject leftArrow;
	public GameObject upArrow;
	public GameObject attack;
	public GameObject SpoonText;
	public bool attacking;
	public int spoons;
	public float currentSpoonDuration;

	// Use this for initialization
	void Start () {
		rightArrow.SetActive (false);
		leftArrow.SetActive (false);
		upArrow.SetActive (false);
	}
	
	// Update is called once per frame
	void Update () {
		rightArrow.SetActive (false);
		leftArrow.SetActive (false);
		upArrow.SetActive (false);

		rightArrow.GetComponent<SpriteRenderer> ().color =  new Color(rightArrow.GetComponent<SpriteRenderer> ().color.r, 
																	rightArrow.GetComponent<SpriteRenderer> ().color.g, 
																	rightArrow.GetComponent<SpriteRenderer> ().color.b, 
																	Mathf.PingPong (Time.time, 1f));

		leftArrow.GetComponent<SpriteRenderer> ().color =  new Color(leftArrow.GetComponent<SpriteRenderer> ().color.r, 
																	leftArrow.GetComponent<SpriteRenderer> ().color.g, 
																	leftArrow.GetComponent<SpriteRenderer> ().color.b, 
																	Mathf.PingPong (Time.time, 1f));

		upArrow.GetComponent<SpriteRenderer> ().color =  new Color(upArrow.GetComponent<SpriteRenderer> ().color.r, 
																	upArrow.GetComponent<SpriteRenderer> ().color.g, 
																	upArrow.GetComponent<SpriteRenderer> ().color.b, 
																	Mathf.PingPong (Time.time, 1f));
		if (spoons > 0) {
			
		
			// RIGHT
			RaycastHit2D hit = Physics2D.Raycast (transform.position, Vector2.right / 8, 0.15f, mask);
		
			Vector3 right = transform.TransformDirection (Vector3.right * 0.15f);
			Debug.DrawRay (transform.position, right, Color.red);

			if (hit.collider != null) {
				if (hit.collider.tag == "break") {
					rightArrow.SetActive (true);

					if (Input.GetKeyDown (KeyCode.RightArrow) && !attacking) {
						blockMining (hit.transform.gameObject);
					}
				}
			}

			// LEFT
			hit = Physics2D.Raycast (transform.position, Vector2.left / 8, 0.15f, mask);

			Vector3 left = transform.TransformDirection (Vector3.left * 0.15f);
			Debug.DrawRay (transform.position, left, Color.green);

			if (hit.collider != null) {
				if (hit.collider.tag == "break") {
					leftArrow.SetActive (true);

					if (Input.GetKeyDown (KeyCode.LeftArrow) && !attacking) {
						blockMining (hit.transform.gameObject);
					}
				}
			}

			// UP
			hit = Physics2D.Raycast (transform.position, Vector2.up / 8, 0.15f, mask);

			Vector3 up = transform.TransformDirection (Vector3.up * 0.15f);
			Debug.DrawRay (transform.position, up, Color.red);

			if (hit.collider != null) {
				if (hit.collider.tag == "break") {
					upArrow.SetActive (true);

					if (Input.GetKeyDown (KeyCode.UpArrow) && !attacking) {
						blockMining (hit.transform.gameObject);
					}
				}
			}
		}
	}

	void blockMining(GameObject hit) {
		attacking = true;
		attack.transform.parent.gameObject.SetActive (true);
		attack.GetComponent<AttackScript> ().script = this;
		attack.GetComponent<AttackScript> ().tempBlock = hit;
		attack.GetComponent<AttackScript> ().StartAttack ();
		currentSpoonDuration--;
		if (currentSpoonDuration <= 0) {
			UpdateSpoons (-1);

			if (spoons > 0) {
				currentSpoonDuration = 5;
			}
		
			//break sound
		}
		
	}

	public void UpdateSpoons (int delta) {
		spoons += delta;

		if (spoons > 0 && currentSpoonDuration <= 0) {
			currentSpoonDuration = 5;
		}

		SpoonText.GetComponent<Text>().text = "" + spoons + "x";

	}

	public void DestroyBlock(GameObject block) {
		Destroy (block.transform.GetComponent<BoxCollider2D> ());
		block.GetComponent<SpriteRenderer> ().color =  new Color(block.GetComponent<SpriteRenderer> ().color.r, 
			block.GetComponent<SpriteRenderer> ().color.g, 
			block.GetComponent<SpriteRenderer> ().color.b, 
			0.3f);
	}

	void OnTriggerEnter2D (Collider2D other) {
		if (other.tag == "Spoon") {
			UpdateSpoons (1);

			if (currentSpoonDuration == 0)
				currentSpoonDuration = 5;

			Destroy (other.gameObject);
		}

		if (other.name == "WINGAME") {
			SceneManager.LoadScene (1);
		}
	}
}
