﻿using UnityEngine;
using System.Collections;

public class PlayerControl2D : MonoBehaviour {

	CharacterMoviment2D m_Character;
	public bool locked;

	AudioSource audio;

	Vector3 origin;

	// Use this for initialization
	void Start () {
		m_Character = GetComponent<CharacterMoviment2D> ();

		origin = transform.position;
		audio = GetComponent<AudioSource> ();
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void FixedUpdate () {
		float h = Input.GetAxis ("Horizontal");
		float v = Input.GetAxis ("Vertical");

		if (locked) {
			h = 0;
			v = 0;
		}
			
		m_Character.Move (h, v, false, false);
	}

	public void Lock() {
		m_Character.RbKinematic = true;
		locked = true;

		m_Character.MoveToOrigin (origin);
	}

	public void Unlock() {
		m_Character.RbKinematic = false;
		locked = false;
	}

	public bool Locked {
		get { return locked; }
		set { locked = value; }
	}

	public void StartMusga() {
		audio.Play ();
	}

	public void StopMusga() {
		audio.Stop ();
	}
}
